
FORMAT: 1A
HOST: https://alefba.roshan-ai.ir

# الفبا

نویسه‌خوان الفبا تصویر اسناد فارسی، انگلیسی و عربی را می‌خواند و در قالب متن مرتب ارائه می‌دهد.

برای دسترسی به واسط برنامه‌نویس الفبا نیاز به یک TOKEN_KEY معتبر دارید که برای احراز هویت استفاده می‌شود. لطفا برای آزمایش سامانه، این متغیر را در تقاضاهای نمونه، جای‌گذاری کنید. سوال هم اگر دارید، لطفا برای آدرس alefba@roshan-ai.ir بنویسید.


## خواندن سند [/api/read_document/]

این تابع، یک سند را دریافت می‌کند و متن صفحات آن را در قالب JSON باز می‌گرداند. خروجی نویسه‌خوان شامل بخش‌های نوشته (پاراگراف)، جدول و تصویر است. مکان و ابعاد هر بخش در خروجی مشخص شده است و اطلاعات کامل خطوط متن در بخش نوشته ظاهر می‌شود. برای هر خط متن، ویژگی احتمال صحت هم قرار داده شده که نشان می‌دهد ابزار نویسه‌خوان چقدر از نتیجه تحلیل، مطمئن است.

### نمونه ارسال با لینک سند[POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - document_url: URL (string, required) - آدرس سند ورودی
        - type: general (enum[string]) - این ویژگی نوع سند را مشخص می‌کند
            + Members
                + `general` - سندهای عمومی
                + `ID-card` - کارت‌های شناسایی
                + `excel` - جدولهای مالی
        - fix_orientation: true (boolean) - در صورت فعال بودن این ویژگی، الفبا سعی می‌کند چرخش ۹۰، ۱۸۰ و یا ۲۷۰ درجه تصویر را اصلاح کند
        - word_positions: true (boolean) - در صورت فعال بودن این ویژگی اطلاعات مکانی واژه‌ها در خروجی قرار می‌گیرد
        - wait: true (boolean) - اگر این ویژگی فعال باشد، کاربر منتظر می‌ماند تا نتیجه تحلیل آماده شود؛ در غیر این صورت، تقاضای تحلیل دریافت می‌شود و کاربر با استفاده از واسط «وضعیت سند» از میزان پیشرفت تحلیل مطلع می‌شود. به این ترتیب پس از پایان پردازش، تقاضای جدیدی برای پردازش سند ارسال می‌شود و این بار تقاضا با نتیجه مناسب پاسخ داده می‌شود.
        - priority: 3 (number) - این ویژگی اولویت درخواست را تعیین می‌کند. مقدار آن می‌تواند بین ۱ تا ۴ باشد. عدد کمتر نشان‌دهندهٔ اولویت بالاتر است.

    + Body

            {
              "document_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf",
              "fix_orientation": true,
              "word_positions": false,
              "type": "general",
              "wait": true,
              "priority": 3
            }

+ Response 200

        {
          "document_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf",
          "pages": [{
            "page_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf@page=1",
            "width": 2125,
            "height": 2750,
            "text": "بوته\n\nدرس‌های دانشگاهی معمولا با پروژه‌هابی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها\n...",
            "parts": [
              {
                "type": "text",
                "direction": "rtl",
                "box": "209 305 1711 449",
                "text": "درس‌های دانشگاهی معمولا با پروژه‌هابی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها\n...",
                "lines": [
                  {
                    "probability": 1.0,
                    "box": "211 305 1707 57",
                    "text": "درس‌های دانشگاهی معمولا با پروژه‌هایی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها"
                  },
                  ...
                ]
              },
              ...
            ]
          },{
            "page_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf@page=2",
            "width": 2125,
            "height": 2750,
            "text": "انجام این کار البته چندان هم آسان نیست؛ نه برای دانشجوها و نه برای کمک‌استادها، اما حاصل بسیار شیرین\n...",
            "parts": [
              {
                "type": "text",
                "direction": "rtl",
                "box": "210 110 1714 294",
                "text": "انجام این کار البته چندان هم آسان نیست؛ نه برای دانشجوها و نه برای کمک‌استادها، اما حاصل بسیار شیرین\n...",
                "lines": [
                  {
                    "probability": 1.0,
                    "box": "210 110 1706 58",
                    "text": "انجام این کار البته چندان هم آسان نیست؛ نه برای دانشجوها و نه برای کمک‌استادها، اما حاصل بسیار شیرین"
                  },
                  ...
                ],
              },
              ...
            ]
          }]
        }

### نمونه درخواست به صورت ناهمگام[POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

   + Attributes

        - document_url: URL (string, required) - آدرس سند ورودی
        - type: general (enum[string]) - این ویژگی نوع سند را مشخص می‌کند
            + Members
                + `general` - سندهای عمومی
                + `ID-card` - کارت‌های شناسایی
                + `excel` - جدولهای مالی
        - fix_orientation: true (boolean) - در صورت فعال بودن این ویژگی، الفبا سعی می‌کند چرخش ۹۰، ۱۸۰ و یا ۲۷۰ درجه تصویر را اصلاح کند
        - word_positions: true (boolean) - در صورت فعال بودن این ویژگی اطلاعات مکانی واژه‌ها در خروجی قرار می‌گیرد
        - wait: true (boolean) - اگر این ویژگی فعال باشد، کاربر منتظر می‌ماند تا نتیجه تحلیل آماده شود؛ در غیر این صورت، تقاضای تحلیل دریافت می‌شود و کاربر با استفاده از واسط «وضعیت سند» از میزان پیشرفت تحلیل مطلع می‌شود. به این ترتیب پس از پایان پردازش، تقاضای جدیدی برای پردازش سند ارسال می‌شود و این بار تقاضا با نتیجه مناسب پاسخ داده می‌شود.
        - priority: 3 (number) - این ویژگی اولویت درخواست را تعیین می‌کند. مقدار آن می‌تواند بین ۱ تا ۴ باشد. عدد کمتر نشان‌دهندهٔ اولویت بالاتر است.

    + Body

            {
              "document_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf",
              "fix_orientation": true,
              "word_positions": false,
              "type": "general",
              "wait": false,
              "priority": 3
            }

+ Response 200
      {
        "state":"PENDING",
        "task_ids": "..."
      }


### نمونه دریافت نتیجه در حالت ناهمگام [POST]
+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

   + Attributes

        - task_id: ID (number, required) - شناسه درخواست ارسال شده
        - wait: true (boolean) - اگر این ویژگی فعال باشد، کاربر منتظر می‌ماند تا نتیجه تحلیل آماده شود؛ در غیر این صورت، تقاضای تحلیل دریافت می‌شود و کاربر با استفاده از واسط «وضعیت سند» از میزان پیشرفت تحلیل مطلع می‌شود. به این ترتیب پس از پایان پردازش، تقاضای جدیدی برای پردازش سند ارسال می‌شود و این بار تقاضا با نتیجه مناسب پاسخ داده می‌شود.

    + Body

            {
              "task_id": "...",
              "wait": false
            }

+ Response 200
      {
        "state":"started",
        "task_id": "..."
      }

### نمونه ارسال مستقیم سند [POST]

+ Request (multipart/form-data; boundary={boundary value})

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - document: file in binary (string, required) - فایل سند ورودی
        - type: general (enum[string]) - این ویژگی نوع سند را مشخص می‌کند
            + Members
                + `general` - سندهای عمومی
                + `ID-card` - کارت‌های شناسایی
                + `excel` - جدولهای مالی
        - fix_orientation: true (boolean) - در صورت فعال بودن این ویژگی، الفبا سعی می‌کند چرخش ۹۰، ۱۸۰ و یا ۲۷۰ درجه تصویر را اصلاح کند
        - word_positions: true (boolean) - در صورت فعال بودن این ویژگی اطلاعات مکانی واژه‌ها در خروجی قرار می‌گیرد
        - wait: true (boolean) - اگر این ویژگی فعال باشد، کاربر منتظر می‌ماند تا نتیجه تحلیل آماده شود؛ در غیر این صورت، تقاضای تحلیل دریافت می‌شود و کاربر با استفاده از واسط «وضعیت سند» از میزان پیشرفت تحلیل مطلع می‌شود. به این ترتیب پس از پایان پردازش، تقاضای جدیدی برای پردازش سند ارسال می‌شود و این بار تقاضا با نتیجه مناسب پاسخ داده می‌شود.
        - priority: 3 (number) - این ویژگی اولویت درخواست را تعیین می‌کند. مقدار آن می‌تواند بین ۱ تا ۴ باشد. عدد کمتر نشان‌دهندهٔ اولویت بالاتر است.

    + Body

            --{boundary value}
            Content-Disposition: form-data; name='document'; filename='FILE NAME'
            Content-Type: text/plain (according to the type of the uploaded file)

            {file content}
            --{boundary value}


+ Response 200
        {
          "pages": [{
            "page_url": "http://alefba.roshan-ai.ir/media/files/96/84/859267728361-boute.pdf@page=1",
            "width": 2125,
            "height": 2750,
            "text": "بوته\n\nدرس‌های دانشگاهی معمولا با پروژه‌هابی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها\n...",
            "parts": [
              {
                "type": "text",
                "direction": "rtl",
                "box": "209 305 1711 449",
                "text": "درس‌های دانشگاهی معمولا با پروژه‌هابی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها\n...",
                "lines": [
                  {
                    "probability": 1.0,
                    "box": "211 305 1707 57",
                    "text": "درس‌های دانشگاهی معمولا با پروژه‌هایی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها"
                  },
                  ...
                ]
              },
              ...
            ]
          },{
            "page_url":"http://alefba.roshan-ai.ir/media/files/96/84/859267728361-boute.pdf@page=2",
            "width": 2125,
            "height": 2750,
            "text": "انجام این کار البته چندان هم آسان نیست؛ نه برای دانشجوها و نه برای کمک‌استادها، اما حاصل بسیار شیرین\n...",
            "parts": [
              {
                "type": "text",
                "direction": "rtl",
                "box": "210 110 1714 294",
                "text": "انجام این کار البته چندان هم آسان نیست؛ نه برای دانشجوها و نه برای کمک‌استادها، اما حاصل بسیار شیرین\n...",
                "lines": [
                  {
                    "probability": 1.0,
                    "box": "210 110 1706 58",
                    "text": "انجام این کار البته چندان هم آسان نیست؛ نه برای دانشجوها و نه برای کمک‌استادها، اما حاصل بسیار شیرین"
                  },
                  ...
                ],
              },
              ...
            ]
          }],
          "document_url":"http://alefba.roshan-ai.ir/media/files/96/84/859267728361-boute.pdf"
        }


## خواندن صفحه [/api/read_pages/]

این تابع، تصویر نوشته را دریافت می‌کند و متن آن را در قالب JSON باز می‌گرداند. خروجی نویسه‌خوان شامل بخش‌های نوشته (پاراگراف)، جدول و تصویر است. مکان و ابعاد هر بخش در خروجی مشخص شده است و اطلاعات کامل خطوط متن در بخش نوشته ظاهر می‌شود. برای هر خط متن، ویژگی احتمال صحت هم قرار داده شده که نشان می‌دهد ابزار نویسه‌خوان چقدر از نتیجه تحلیل، مطمئن است.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - page_urls: URL (array[string], required) - آدرس صفحات ورودی
        - type: general (enum[string]) - این ویژگی نوع سند را مشخص می‌کند
            + Members
                + `general` - سندهای عمومی
                + `ID-card` - کارت‌های شناسایی
                + `excel` - جدولهای مالی
        - fix_orientation: true (boolean) - در صورت فعال بودن این ویژگی، الفبا سعی می‌کند چرخش ۹۰، ۱۸۰ و یا ۲۷۰ درجه تصویر را اصلاح کند
        - word_positions: true (boolean) - در صورت فعال بودن این ویژگی اطلاعات مکانی واژه‌ها در خروجی قرار می‌گیرد
        - wait: true (boolean) - اگر این ویژگی فعال باشد، کاربر منتظر می‌ماند تا نتیجه تحلیل آماده شود؛ در غیر این صورت، تقاضای تحلیل دریافت می‌شود و کاربر با استفاده از واسط «وضعیت سند» از میزان پیشرفت تحلیل مطلع می‌شود. به این ترتیب پس از پایان پردازش، تقاضای جدیدی برای پردازش سند ارسال می‌شود و این بار تقاضا با نتیجه مناسب پاسخ داده می‌شود.
        - priority: 3 (number) - این ویژگی اولویت درخواست را تعیین می‌کند. مقدار آن می‌تواند بین ۱ تا ۴ باشد. عدد کمتر نشان‌دهندهٔ اولویت بالاتر است.

    + Body

            {
              "page_urls": ["http://bayanbox.ir/view/5067853395275628881/boute.pdf@page=1"],
              "fix_orientation": true,
              "word_positions": false,
              "wait": true,
              "priority": 3
            }

+ Response 200

        [{
          "page_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf@page=1",
          "width": 2125,
          "height": 2750,
          "text": "بوته\n\nدرس‌های دانشگاهی معمولا با پروژه‌هابی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها\n...",
          "parts": [
            {
              "type": "text",
              "direction": "rtl",
              "box": "209 305 1711 449",
              "text": "درس‌های دانشگاهی معمولا با پروژه‌هابی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها\n...",
              "lines": [
                {
                  "probability": 1.0,
                  "box": "211 305 1707 57",
                  "text": "درس‌های دانشگاهی معمولا با پروژه‌هایی همراه هستند که سهم قابل‌توجهی از آموزش را بر عهده دارند. این پروژه‌ها"
                },
                ...
              ]
            },
            ...
          ]
        }]


## وضعیت سند [/api/document_status/]

این تابع برای هر کدام از سندهای ورودی مشخص می‌کند که چه تعداد از صفحات آنها تحلیل شده است.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - document_urls: URL (array[string], required) - آدرس اسناد ورودی
 
    + Body

            {
              "document_urls": ["http://bayanbox.ir/view/5067853395275628881/boute.pdf"]
            }

+ Response 200

        {
          "http://bayanbox.ir/view/5067853395275628881/boute.pdf": {
            "analyzed": true,
            "processed_pages": 2,
            "all_pages": 2
          }
        }


## صفحات سند [/api/document_pages/]

نویسه‌خوان برای تحلیل سند، ابتدا باید آن را صفحه‌صفحه کند. این تابع، فایل سند را در قالب PDF دریافت می‌کند و صفحات آن را به عنوان نتیجه باز می‌گرداند. بعد از این مرحله، تابع «خواندن صفحه» می‌تواند هر کدام از صفحه‌های سند را تحلیل کند.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - document_url: URL (string, required) - آدرس سند ورودی
 
    + Body

            {
              "document_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf"
            }

+ Response 200

        {
          "document_url":"http://bayanbox.ir/view/5067853395275628881/boute.pdf",
          "pages": [
            "http://bayanbox.ir/view/5067853395275628881/boute.pdf@page=1",
            "http://bayanbox.ir/view/5067853395275628881/boute.pdf@page=2"
          ]
        }


## دریافت فایل ورد [/api/download_word/]

با استفاده از این تابع می‌توانید نتیجه صفحات پردازش شده را در قالب فایل Microsoft Word دریافت نمایید. در فایل خروجی، قالب سند حفظ شده است و اجزای متن شامل خطوط، پاراگراف‌ها و خانه‌های جدول در جای خود قرار گرفته‌اند.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - document_url: URL (string, required) - آدرس سند ورودی

    + Body

            {
              "document_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf"
            }

+ Response 200

    boute.docx file


## دریافت فایل اکسل [/api/download_excel/]

با استفاده از این تابع می‌توانید نتیجه صفحات پردازش شده را در قالب فایل Microsoft Excel دریافت نمایید. دقت کنید که برای استفاده از این خروجی لازم است در هنگام خواندن سند، ویژگی <code>type</code> را برابر مقدار <code>excel</code> قرار دهید.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - document_url: URL (string, required) - آدرس سند ورودی

    + Body

            {
              "document_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf"
            }

+ Response 200

    boute.xlsx file

## دریافت فایل قابل جستجو [/api/download_pdf/]

با استفاده از این تابع می‌توانید نتیجه صفحات پردازش شده را در قالب فایل PDF دریافت نمایید. فایل خروجی، تصاویر صفحات سند ورودی را به همراه نتیجه پردازش آنها نشان می‌دهد. به این ترتیب با جستجوی یک عبارت در این فایل، واژه‌های مورد جستجو در تصویر مشخص و رنگی می‌شوند.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - document_url: URL (string, required) - آدرس سند ورودی
        - quality: 100 (number) - مقدار dpi کیفیت صفحات
        - color: false (boolean) - در صورت فعال بودن این خصوصیت، فایل خروجی رنگی خواهد بود.

    + Body

            {
              "document_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf",
              "quality": 100,
              "img_format": "png",
              "color": false
            }

+ Response 200

    boute.pdf file

## حذف سند [/api/delete_document/]

با استفاده از این تابع می‌توانید سند ثبت شده در سامانه را به طور کامل حذف کنید.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY

    + Attributes

        - document_url: URL (string, required) - آدرس سند ورودی

    + Body

            {
              "document_url": "http://bayanbox.ir/view/5067853395275628881/boute.pdf"
            }

+ Response 200

        {
          "message":"Document deleted successfully."
        }

## خواندن سند نامتقارن [/api/read_document/]

این قابلیت برای جلوگیری از انتظار برای تحلیل فایل قرار داده شده است. پس  از ارسال رکوئست وضعیت فایل در حال تحلیل قرار گرفته و پس اتمام تحلیل رکوئست کالبک حاوی اطلاعات فایل به آدرس وارد شده فرستاده میشود.

### نمونه [POST]

+ Request (application/json)

    + Headers

            Authorization: Token TOKEN_KEY
            Content-Type: application/json

    + Attributes

        - document_url: URL (string, required) - آدرس سند ورودی
        - color: URL (string, required) - آدرس بازگشت بعد از تمام شدن فرآیند خواندن سند

    + Body

            {
              "document_url": "http://alefba.roshan-ai.ir/media/files/46/00/166072370361-internship.pdf",
              "callback_url": "http://192.168.254.3:5013/alefba_post"
            }

+ Response 200

        {
          "state":"processing",
          "document_url":"http://192.168.254.3:5013/static/2021-10-12%20%281%29.png"
        }
